@echo off
title  Fix DNS

::  Set Path variable, it helps if it is misconfigured in the system

set "PATH=%SystemRoot%\System32;%SystemRoot%\System32\wbem;%SystemRoot%\System32\WindowsPowerShell\v1.0\"
if exist "%SystemRoot%\Sysnative\reg.exe" (
set "PATH=%SystemRoot%\Sysnative;%SystemRoot%\Sysnative\wbem;%SystemRoot%\Sysnative\WindowsPowerShell\v1.0\;%PATH%"
)

>nul fltmc || (
echo:
echo ERROR: Right click on the script and 'Run as administrator'
goto Done
)

set winbuild=1
for /f "tokens=6 delims=[]. " %%G in ('ver') do set winbuild=%%G
set line=_________________________________________________________________________________________________

if %winbuild% LSS 9200 (
echo:
echo ERROR: Unsupported OS version Detected.
echo This script is supported only for Windows 8/8.1/10/11
goto Done
)

cls
mode 98, 30

echo:
echo %line%
echo:
echo      Notes:
echo:
echo       - Fix DNS option resolves Internet issues if system's DNS is not working properly.
echo:
echo       - It will check 6 DNS servers in below order and will apply first 4 working servers.
echo:
echo         1.1.1.1, 8.8.4.4, 1.0.0.1, 8.8.8.8, 208.67.222.222, 208.67.220.220
echo:
echo %line%
echo:
choice /C:120 /N /M ">    [1] Fix DNS  [2] Reset [0] Exit : "
if %errorlevel%==3 exit /b
if %errorlevel%==2 goto :undo
if %errorlevel%==1 goto :fixdns

:fixdns

cls
mode 108, 30
echo:
echo Initializing...
echo:

::  Check Internet connection

set _int=
for /f "delims=[] tokens=2" %%# in ('ping -n 1 dns.msftncsi.com') do if not [%%#]==[] set _int=1

if not defined _int (
powershell "If([Activator]::CreateInstance([Type]::GetTypeFromCLSID([Guid]'{DCB00C01-570F-4A9B-8D69-199FDBA5723B}')).IsConnectedToInternet){Exit 0}Else{Exit 1}"
)

if not defined _int if not "%errorlevel%"=="0" (
echo:
echo ERROR: Internet is not connected. Aborting...
goto Done
)

powershell "$f=[io.file]::ReadAllText('%~f0') -split ':dns\:.*';iex ($f[1]);"
ipconfig /flushdns
goto Done

:dns:
$dnsServers = @("1.1.1.1", "8.8.4.4", "1.0.0.1", "8.8.8.8", "208.67.222.222", "208.67.220.220")
$adapter = Get-NetAdapter -Physical
$adapter | Set-DnsClientServerAddress -ResetServerAddresses

$workingDnsServers = @()
$count = 0

foreach ($dnsServer in $dnsServers) {
    if (Resolve-DnsName -Name dns.msftncsi.com -Server $dnsServer -ErrorAction SilentlyContinue) {
        $workingDnsServers += $dnsServer
        $count++
    }
    if($count -eq 4) {
        break
    }
}

$adapter | Set-DnsClientServerAddress -ServerAddresses $workingDnsServers
$adapter | Get-DnsClientServerAddress
:dns:

:undo

cls
mode 108, 30
echo:
echo Resetting DNS servers to default...

powershell "Get-NetAdapter -Physical | Set-DnsClientServerAddress -ResetServerAddresses"
ipconfig /flushdns
powershell Get-DnsClientServerAddress

:Done
echo:
echo Press any key to exit...
pause >nul
exit /b
